// assume that version is lt 5
// property existence constraints for all metric nodes
CREATE CONSTRAINT metrics_agentId_exists ON (m:Metric) ASSERT EXISTS (m.agentId);
CREATE CONSTRAINT metrics_instanceId_exists ON (m:Metric) ASSERT EXISTS (m.instanceId);
CREATE CONSTRAINT metrics_name_exists ON (m:Metric) ASSERT EXISTS (m.name);
CREATE CONSTRAINT metrics_timestamp_exists ON (m:Metric) ASSERT EXISTS (m.timestamp);

// property existence constraints for counter metric nodes
CREATE CONSTRAINT counter_count_exists ON (m:Counter) ASSERT EXISTS (m.count);

// property existence constraints for gauge metric nodes
CREATE CONSTRAINT gauge_count_exists ON (m:Gauge) ASSERT EXISTS (m.value);

// property existence constraints for summary metric nodes
CREATE CONSTRAINT summary_sample_sum_exists ON (m:Summary) ASSERT EXISTS (m.sampleSum);
CREATE CONSTRAINT summary_sample_count_exists ON (m:Summary) ASSERT EXISTS (m.sampleCount);
CREATE CONSTRAINT summary_quantiles_exists ON (m:Summary) ASSERT EXISTS (m.quantiles);

// property existence constraints for histogram metric nodes
CREATE CONSTRAINT histogram_sample_sum_exists ON (m:Histogram) ASSERT EXISTS (m.sampleSum);
CREATE CONSTRAINT histogram_sample_count_exists ON (m:Histogram) ASSERT EXISTS (m.sampleCount);
CREATE CONSTRAINT histogram_buckets_exists ON (m:Histogram) ASSERT EXISTS (m.buckets);

// index for range queries
CREATE INDEX metrics FOR (m:Metric) ON (m.timestamp, m.name, m.agentId, m.instanceId);
